/*****
*
* Copyright (C) 1998,1999,2000 Vandoorselaere Yoann
* All Rights Reserved
*
* This file is part of the Prelude program.
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by 
* the Free Software Foundation; either version 2, or (at your option)
* any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; see the file COPYING.  If not, write to
* the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
*
*****/

#include <errno.h>
#include <string.h>

#define err(x...) do { \
	 fprintf(stderr, "%s():%d : ", __FUNCTION__, __LINE__); \
		 fprintf(stderr, x); \
		 fprintf(stderr, ": %s.\n", strerror(errno)); \
} while(0)

#define do_init(func, name) do {                         \
        p_print(stdout, "- %s\n", name);                 \
        if ( (func) < 0 )                                \
               exit(1);                                  \
} while(0);
