#include <stdio.h>
#include <getopt.h>

#include "detect.h"

static void _debug_run(Packet_t *packet, int depth);
static int _check_opts(int argc, char **argv);



static subscribtion_t subscribtion[] = {
        { p_all, NULL },
        { p_end, NULL },
};

static plugin_detect_t plugin = {
        "Debug",
        "Yoann Vandoorselaere",
        "This is a debug plugin, that warn on each packet.",
        _check_opts,
        _debug_run,
        subscribtion,
};


static int enabled = 0;


static void _debug_run(Packet_t *packet, int depth) 
{
        if ( enabled )
                plugin_do_report((plugin_generic_t *) &plugin, packet, normal,
                                 "This is a debuging message by the debug plugin");

}



static void print_help(void) 
{
        fprintf(stderr, "\t -e --enable-debug (default to disable)\n");
}



static int _check_opts(int argc, char **argv) 
{
        int c;
        struct option opts[] = {
                { "enable-debug", no_argument, NULL, 'e' },
        };
        
        if ( argc == 0 ) {
                print_help();
                return 0;
        }
        
        while ( 1 ) {
                c = getopt_long(argc, argv, "e", opts, NULL);
                
                switch (c) {

                case 'e':
                        enabled = 1;
                        break;
                        
                case -1:
                        return 0;
                        
                default:                        
                        print_help();
                        return -1;
                }
        }
        
        return 0;
}


plugin_detect_t *plugin_init(unsigned int id)
{               
        return &plugin;
}
