/*****************************************************************************
 * Prelude                                                                   *
 *                                                                           *
 * (C) 1998 - 2000, Vandoorselaere Yoann                                     *
 *****************************************************************************/

/*****
*
* Copyright (C) 1999 Vandoorselaere Yoann
* All Rights Reserved
*
* This file is part of the Prelude program.
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by 
* the Free Software Foundation; either version 2, or (at your option)
* any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; see the file COPYING.  If not, write to
* the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
*
*****/

#include "proto.h"

struct ssh_hdr 
{
        int version;
        char server_key[1500];
        char client_key[1500];
} ssh_hdr;


void init(ProtoPlugins_t *plugin) 
{
        plugin->author = "Author <author@mydomain.org>";
        plugin->name = "Ssh_dec";
        plugin->desc = "Ssh header decoding";
        plugin->uplevel_header = p_tcp;
}

/*
 * Called by prelude
 * each time a new packet is received & we wanna
 * see if X part of the packet is an ssh header.
 */
void run(unsigned char *data, unsigned int len) 
{
        /*
         * here we need to write a routine
         * to verify that the data contain an ssh header.
         */
        memcpy(ssh_hdr.version, data, sizeof(int));
        data += sizeof(int);
        memcpy(ssh_hdr.server_key, data, sizeof(ssh_hdr.server_key));
        data += sizeof(ssh_hdr.server_key);
        memcpy(ssh_hdr.client_key, data, sizeof(ssh_hdr.client_key));
}

/*
 * Called by prelude if a detect plugins
 * find a security problem.
 */
void encode_header(XDR *xdrs) 
{
        xdr_string(xdrs, "ssh version");
        xdr_int(xdrs, &ssh_hdr.version);

        xdr_string(xdrs, "ssh server key");
        xdr_string(xdrs, &ssh_hdr.server_key);

        xdr_string(xdrs, "ssh client key");
        xdr_string(xdrs, &ssh_hdr.client_key);
}

        
        
        
