/*****
*
* Copyright (C) 2000 Yoann Vandoorselaere <yoann@mandrakesoft.com>
* All Rights Reserved
*
* This file is part of the Prelude program.
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by 
* the Free Software Foundation; either version 2, or (at your option)
* any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; see the file COPYING.  If not, write to
* the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
*
*****/

#include <stdio.h>
#include <unistd.h>
#include <string.h>
#include <report.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <errno.h>

#include <tcpd.h>
#include <syslog.h>

void plug_run(DetectReport_t *report);
int plug_init(ReportPublic_t *plugin);

#define MAX_CNX 10
#define PORT 4001
#define HOST "127.0.0.1"

//static int sock[MAX_CNX];
static int clnt_sock;
static int tvar;

static int _handle_inet_connection(int srv_sock, struct sockaddr_in *addr) 
{
        int ret, len;
        int i, status;
        struct request_info request;

        tvar = 9;
        
        len = sizeof(*addr);

        clnt_sock = accept(srv_sock, (struct sockaddr *) addr, &len);
        request_init(&request, RQ_DAEMON, "report-srv", RQ_FILE, clnt_sock, 0);
        
        printf("FD = %d\n", clnt_sock);

        fromhost(&request);
        ret = hosts_access(&request);
        if ( ! ret ) {
                //       close(sock[i]);
                // sock[i] = -1;
                //  continue;
        }
        
        syslog(allow_severity, "report-srv: connect from %s", eval_client(&request));
}

static int _inet_server_start(void) 
{
        int ret, srv_sock;
        struct sockaddr_in addr;
        pid_t pid;
        
        srv_sock = socket(AF_INET, SOCK_STREAM, IPPROTO_TCP);
        if ( srv_sock < 0 ) {
                perror("socket");
                return -1;
        }
        
        addr.sin_family = AF_INET;
        addr.sin_port = htons(PORT);
        addr.sin_addr.s_addr = inet_addr(HOST);

        ret = bind(srv_sock, (struct sockaddr *) &addr, sizeof(addr));
        if ( ret < 0 ) {
                close(srv_sock);
                fprintf(stderr, "bind: %s.\n", strerror(errno));
                return -1;
        }
        
        ret = listen(srv_sock, 1);
        if ( ret < 0 ) {
                perror("listen");
                return -1;
        }

        pid = fork();
        if ( pid == 0 ) {
                _handle_inet_connection(srv_sock, &addr);
                exit(0);
        }

        close(srv_sock);
        
        return 0;
}


int plug_init(ReportPublic_t *plugin) {
        int ret;
                
        plugin->name = "ReportSrv";
        plugin->desc = "This is a report server, for remote client reporting.";

        //memset(sock, -1, sizeof(sock));
        
        ret = _inet_server_start();
        if ( ret < 0 )
                return -1;
        
	return 0;
}

void plug_run(DetectReport_t *infos) {
        int i, j;
        const char **ret;

        printf("%d\n", tvar);
        
        printf("FD = %d\n", clnt_sock);
        
        ret = prelude_PktDump(infos->packet);
        for ( i = 0; i < MAX_CNX; i++ )
            write(clnt_sock, ret[i], strlen(ret[i]));

#if 0
        ret = prelude_HexDump(infos->packet);
        if ( ret )
                for ( i = 0; i < MAX_CNX; i++ )
                        write(clnt_sock, ret[i], strlen(ret[i]));

#endif
}













