#include <stdio.h>
#include <string.h>

#include <netinet/in.h>
#include <netinet/if_ether.h>
#include "packet.h"

#include "tcpdump-func.h"

static char hex[] = "0123456789abcdef";

const char *etheraddr_string(const unsigned char *ep) 
{
        char *ptr;
        unsigned int i, j;
        static char buf[sizeof("00:00:00:00:00:00")];
        
        ptr = buf;
        if ((j = *ep >> 4) != 0)
                *ptr++ = hex[j];
        *ptr++ = hex[*ep++ & 0xf];
        
        for (i = 5; (int)--i >= 0;) {
                *ptr++ = ':';
                if ((j = *ep >> 4) != 0)
                        *ptr++ = hex[j];
                *ptr++ = hex[*ep++ & 0xf];
        }
        *ptr = '\0';

        return buf;
}


const char *ipaddr_string(const unsigned char *ap) 
{
        struct in_addr addr;
        
        memcpy(&addr, ap, sizeof(addr));
        
        return inet_ntoa(&addr);
}

        
        
