/*****
*
* Copyright (C) 1999, 2000 Yoann Vandoorselaere <yoann@mandrakesoft.com>
* All Rights Reserved
*
* This file is part of the Prelude program.
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by 
* the Free Software Foundation; either version 2, or (at your option)
* any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; see the file COPYING.  If not, write to
* the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
*
*****/

#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <errno.h>

#include "daemonize.h"
#include "common.h"
#include "print.h"


int daemonize(void)
{
	pid_t pid;

	pid = fork();
	if (pid < 0) {
                err("fork failed");
		return -1;
	} else if (pid) {
		/*
                 * Parent
                 */
		p_print(stdout, "Prelude started, daemon PID is %d\n", (int) pid);
		exit(0);
	} else {
		/*
                 * Child
                 */
		chdir("/");
		umask(0);
	}

        return 0;
}






