/*****
*
* Copyright (C) 1998 - 2000 Yoann Vandoorselaere <yoann@mandrakesoft.com>
* All Rights Reserved
*
* This file is part of the Prelude program.
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by 
* the Free Software Foundation; either version 2, or (at your option)
* any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; see the file COPYING.  If not, write to
* the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
*
*****/

#include <stdio.h>
#include <stdarg.h>
#include <stdlib.h>
#include <time.h>
#include <errno.h>
#include <string.h>

#include <sys/time.h>

#include "packet.h"
#include "plugin-common.h"
#include "plugin-detect.h"
#include "detect-plugins-api.h"
#include "common.h"
#include "alert.h"
#include "alert-prv.h"
#include "timer.h"
#include "rqueue.h"
#include "recycler.h"


void packet_release(Packet_t *packet)
{
        int i;

        for ( i = 0; packet[i].proto != p_end; i++ )
                RecyclerReleaseChunk(packet[i].p.ip);
        
        RecyclerReleaseChunk(packet);
}

void packet_lock(Packet_t *packet) 
{
        int i;

        for (i = 0; packet[i].proto != p_end; i++ )
                RecyclerLockChunk(packet[i].p.ip);
        
        RecyclerLockChunk(packet);
}


#if 0
/*
 * Check if a Packet_t contain the given proto, with
 * depth 'pdepth'.
 *
 * This allow us to access the packet like an hash,
 * instead of searching throught it.
 *
 * For protocol which do not have a fixed depth,
 * we end up searching but at a specified minimum depth.
 */
extern int depth;

int prelude_GetDepth(const Packet_t *packet, proto_enum_t proto,
                     proto_depth_t pdepth)
{
        int i;

        for ( i = 0; packet[i].proto != p_end; i++ ) {
                if ( packet[i].proto == proto )
                        return i;
        }

        return -1;
}

#endif




