#ifndef _PLUGIN_CRYPT_H

#define _PLUGIN_CRYPT_H

/*
 * Definitions of a 'crypt' plugin.
 */

typedef struct {
        PLUGIN_GENERIC; /* see libprelude/include/plugin-generic.h */

        KEY (*make_key)(void);
        void (*init_session)(KEY key, DATA **session_data);
        void (*crypt_buffer)(DATA *session_data, BUFFER* buf, int n, BUFFER* recept);
        void (*decrypt_buffer)(DATA* session_data, BUFFER* buf, int n, BUFFER* recept);
        void (*end_session)(DATA* session_data);
        
} plugin_crypt_t;


/*
 * This one must be changed,
 * this is a wrong assumption that a plugin, can only
 * contain one object (a plugin (the .so) should be able to
 * containe > 1 internal plugin...
 *
 * to avoid that, a good solution would be to implement a
 * plugin_register() function call, that a plugin can call
 * as many time it want, passing it it's own object(s).
 */
plugin_crypt_t *plugin_init(unsigned int id);


#endif
    
