/*****
*
* Copyright (C) 2000 Yoann Vandoorselaere <yoann@mandrakesoft.com>
* All Rights Reserved
*
* This file is part of the Prelude program.
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by 
* the Free Software Foundation; either version 2, or (at your option)
* any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; see the file COPYING.  If not, write to
* the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
*
*****/

/* HTAB = 4 */
/****************************************************************************
 * recycler.h -- Declarations de la bibliotheque recycler.					*
 *--------------------------------------------------------------------------*
 * (c) 2000 Bertrand Petit, tous droits reserves.							*
 ****************************************************************************/

#ifndef LIBRECYCLER_H
#define LIBRECYCLER_H

/****************************************************************************
 * Definitions de types.													*
 ****************************************************************************/
/* Handle d'un recycleur. */
typedef struct _recycler recycler_t;

/* Valeurs de verite. Il est ogligatoire que la va leur de la macro
 * FALSE soit l'entier zero. La valeur de TRUE importe peut du comment
 * qu'elle est entiere et differente de zero.
 */
#ifndef FALSE
#define FALSE 0
#endif
#ifndef TRUE
#define TRUE (-1)
#endif

/****************************************************************************
 * Prototypes.																*
 ****************************************************************************/
extern recycler_t *RecyclerCreate(size_t ChunkSize,
				  unsigned int ChunksMax);
extern int RecyclerDestroy(recycler_t * Recycler, int Force);
extern int RecyclerGrow(recycler_t * Recycler, unsigned int ChunksCount);
extern int RecyclerShrink(recycler_t * Recycler, unsigned int ChunksCount);
extern void *RecyclerGetChunk(recycler_t * Recycler);

extern int RecyclerLockChunk(const void *Data);
extern int RecyclerReleaseChunk(const void *Data);
extern int RecyclerIsLocked(const void *data);

extern unsigned int RecyclerGetChunksMax(recycler_t * Recycler);
extern unsigned int RecyclerGetChunksCount(recycler_t * Recycler);
extern int RecyclerHasFreeChunks(recycler_t * Recycler);

#endif

/****************************************************************************
 * Fin du fichier recycler.h												*
 ****************************************************************************/
