/*****
*
* Copyright (C) 2000 Yoann Vandoorselaere <yoann@mandrakesoft.com>
* All Rights Reserved
*
* This file is part of the Prelude program.
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by 
* the Free Software Foundation; either version 2, or (at your option)
* any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; see the file COPYING.  If not, write to
* the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
*
*****/

typedef struct _rqueue {
        alert_t report;
        timer_t timer;
} rqueue_t;


void plugin_rqueue_report(rqueue_t *item, plugin_generic_t *plugin,
                          Packet_t *packet, rkind_t kind, const char *msg, ...);

void prelude_rqueue_report(rqueue_t *item, Packet_t *packet,
                           rkind_t kind, const char *msg, ...);

#define plugin_do_report(plugin, args...) do {       \
        static rqueue_t report;                      \
        plugin_rqueue_report(&report, plugin, args); \
} while (0)

#define prelude_do_report(args...) do {       \
        static rqueue_t report;               \
        prelude_rqueue_report(&report, args); \
} while (0)




